
#include "stdafx.h"
#include "..\common\TFileLOG.h"

#if defined(_DEBUG)
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include "..\common\StdProgHdr.h"

TFileLOG::TFileLOG()
{
	mPERF("TFileLOG::TFileLOG");

	m_pcsf = NULL;
}

TFileLOG::~TFileLOG()
{
	mPERF("TFileLOG::~TFileLOG");

	Close();
	mDELETE(m_pcsf);
}

BOOL TFileLOG::Open(CString* _pcsFilename)
{
	mPERF("TFileLOG::Open");

	try {

		m_pcsf = new CStdioFile(*_pcsFilename, CFile::modeCreate | CFile::modeWrite | CFile::typeText);
		ASSERT(m_pcsf);
	}
	catch(...) {

		// If we can't open the log file in release mode, it's NOT fatal.  The user will get an error message box
		// and the engine will continue to run.  This is by design.
		//
		CString l_cs;
		l_cs.Format("TFileLOG : Open : '%s' could not be opened...\n", *_pcsFilename);
		AfxMessageBox(l_cs);

		ASSERT(FALSE);

		return FALSE;
	}

	return TRUE;
}

void TFileLOG::Close(void)
{
	mPERF("TFileLOG::Close");

	if(!m_pcsf) { return; }

	m_pcsf->Close();
}

// Spit a formatted string to the log.
//
void TFileLOG::WriteString(char* _pch, ...)
{
	mPERF("TFileLOG::WriteString");

	if(!m_pcsf) { return; }

	va_list l_va;
	char l_chOutput[1024];

	va_start(l_va, _pch);
	vsprintf(l_chOutput, _pch, l_va);
	va_end(l_va);

	::strcat(l_chOutput, "\n");

    m_pcsf->WriteString(l_chOutput);
	m_pcsf->Flush();
}

// Spit a formatted string to the log AND display a messagebox for the user.
//
void TFileLOG::WriteStringMsg(char* _pch, ...)
{
	mPERF("TFileLOG::WriteStringMsg");

	if(!m_pcsf) { return; }

	va_list l_va;
	char l_chOutput[1024];

	va_start(l_va, _pch);
	vsprintf(l_chOutput, _pch, l_va);
	va_end(l_va);

	::strcat(l_chOutput, "\n");
    m_pcsf->WriteString(l_chOutput);
	m_pcsf->Flush();

	AfxMessageBox(l_chOutput);
}
